#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "indie_msgs.h"

const char* _indie_fmt_help =
  "Indie computs the smallest fully indicating implementation of a circuit\n"
  "Usage: %s [OPTIONS] [INPUT_FILE_NAMES]\n"
  "  -o,  --output OUTPUT_FILE_NAME   netlist output file [STDOUT]\n"
  "  -i,  --include INC_FILE_NAMES    coma-separated library input files [STDIN]\n"
  "  -p,  --property PRP_FILE_NAMES   coma-separated property input files [STDIN]\n"
  "  -os, --otimisation-space IMPLEMENTATION_NAMES coma-separated implementation names\n"
  "       used for optimisation (by default all available implementations are used)\n"
  "  -gl, --greedy-layerwise          apply greedy layerwise heuristic\n"
  "  -sl, --statistics-level[SL]      statistics level (SL=[0],1,2)\n"
  "  -mi, --max-iteration[MI]         max nomber of iterations per region [1000000]\n"
  "  -h,  --help                      print this help only\n"
  "  -v,  --version                   print version only\n";
const char* _indie_fmt_version =
  "Version %d.%d\n"
  "Last changed at %s\n"
  "Created by Danil Sokolov (E-mail: danil.sokolov@ncl.ac.uk, ICQ#: 30193190)\n"
  "Copyright (c) 2006, University of Newcastle, Newcastle upon Tyne, UK\n";

const int _indie_version_major = 1;
const int _indie_version_minor = 0;
const char* _indie_version_date = "25 April 2005";

//---------------------------------------------------------------------------
char* indie_get_help(char* name)
{
  int len = strlen (_indie_fmt_help) + 2 * strlen (name) + 1;
  char* help = new char [len];
  sprintf (help, _indie_fmt_help, name, name);
  return help;
}

//---------------------------------------------------------------------------
char* indie_get_version (char* name)
{
  int len = strlen (_indie_fmt_version) + strlen (_indie_version_date) + 1;
  char* version = new char [len];
  sprintf (version, _indie_fmt_version, _indie_version_major,
    _indie_version_minor, _indie_version_date);
  return version;
}
