#include "messages.h"
#include "sv_connection.h"
#include "sv_object.h"
#include "sv_port.h"

//---------------------------------------------------------------------------
Connection::Connection(const char* _name, ConnectionType _type, NetArray* _nets) 
: Object(_name), type(_type), container(NULL)
{
  if (_nets)
    nets = new NetArray(_nets->count());
  else
    nets = new NetArray(1);
  addNets(_nets);
}

//---------------------------------------------------------------------------
Connection::Connection(const Connection& connection) 
: Object(connection), type(connection.type), container(connection.container)
{
  nets = new NetArray(connection.nets->count());
  addNets(connection.nets);
}

//---------------------------------------------------------------------------
Connection::~Connection()
{
  delete nets; nets = NULL;
}

//---------------------------------------------------------------------------
void Connection::addNet(Net* net, int position)
{
  if (position < 0)
    nets->add(net);
  else
    nets->insert(net, position);
}

//---------------------------------------------------------------------------
void Connection::addNets(NetArray* _nets)
{
  if (_nets)
  for (int net_index = 0; net_index < _nets->count(); net_index++)
    nets->add( (*_nets)[net_index] );
}
