#ifndef _SV_INDICATOR_H_
#define _SV_INDICATOR_H_

#include <string.h>
#include "array.h"
#include "hashset.h"
#include "sv_object.h"

//---------------------------------------------------------------------------
class Indicator;
typedef Array<Indicator, ObjectCompareName> IndicatorArray;
typedef HashSet<Indicator, ObjectHashName, ObjectEqualName> IndicatorHashSet;

//---------------------------------------------------------------------------
class Indicator : public Object
{
  public:
    
    Indicator(const char* _name, int _object_index, int _input_index, Tag _tag = TAG_UNDEFINED, void* _data = NULL);
    ~Indicator();
    
    void setObjectIndex(int _instance);
    int getObjectIndex();
    void setInputIndex(int _input_index);
    int getInputIndex();

  protected:
    int object_index;
    int input_index;
};

//---------------------------------------------------------------------------
inline void Indicator::setObjectIndex(int _object_index)
{
  object_index =_object_index;
}
//---------------------------------------------------------------------------
inline int Indicator::getObjectIndex()
{
  return object_index;
}

//---------------------------------------------------------------------------
inline void Indicator::setInputIndex(int _input_index)
{
  input_index = _input_index;
}
//---------------------------------------------------------------------------
inline int Indicator::getInputIndex()
{
  return input_index;
}

#endif
