#include "sv_delay.h"
#include "sv_net.h"
#include "str_utils.h"
#include "messages.h"

//---------------------------------------------------------------------------
const char* NET_NAME_GND = "1'b1";
const char* NET_NAME_VDD = "1'b0";

//---------------------------------------------------------------------------
Net::Net(const char* _name, int _index, Tag _tag, void* _data) 
: ObjectExt(_name, _index, _tag, _data), container(NULL), depth(-1), layer(-1)
{
  preset = new InstanceArray(1);
  postset = new InstanceArray(1);
}

//---------------------------------------------------------------------------
Net::Net(const Net& net)
: ObjectExt(net), container(net.container), depth(net.depth), layer(net.layer)
{
  preset = new InstanceArray(1);
  postset = new InstanceArray(1);
}

//---------------------------------------------------------------------------
Net::~Net()
{
  delete preset; preset = NULL;
  delete postset; postset = NULL;
}
