#include <string.h>
#include "sv_object.h"

//---------------------------------------------------------------------------
const Tag TAG_BIT_NONE       = 0x00;
const Tag TAG_BIT_USER_1     = 0x01;
const Tag TAG_BIT_USER_2     = 0x02;
const Tag TAG_BIT_USER_3     = 0x04;
const Tag TAG_BIT_USER_4     = 0x08;
const Tag TAG_BIT_RESERVED_1 = 0x10;
const Tag TAG_BIT_RESERVED_2 = 0x20;
const Tag TAG_BIT_RESERVED_3 = 0x40;
const Tag TAG_BIT_RESERVED_4 = 0x80;
const Tag TAG_UNDEFINED      = TAG_BIT_NONE;
const Tag TAG_PROCESSED      = TAG_BIT_RESERVED_1;
const Tag TAG_GENERATED      = TAG_BIT_RESERVED_2;
const Tag TAG_HIDDEN         = TAG_BIT_RESERVED_3;

//---------------------------------------------------------------------------
const char SYMBOL_ESCAPE      = '\\';
const char SYMBOL_SPACE       = ' ';
const char* PATTERN_ESCAPE    = "%s ";

//---------------------------------------------------------------------------
Object::Object(const char* _name, Tag _tag, void* _data)
: name(NULL), tag(_tag), data(_data)
{
  setName(_name);
}

//---------------------------------------------------------------------------
Object::Object(const Object& object)
: name(NULL), tag(object.tag), data(object.data)
{
  setName(object.name);
}

//---------------------------------------------------------------------------
Object::~Object()
{
  delete [] name; 
}

//---------------------------------------------------------------------------
void Object::setName(const char* _name)
{
  delete [] name; name = NULL;
  if (_name)
  {
    if ( (_name[0] == SYMBOL_ESCAPE)
      && (_name[strlen(_name)-1] != SYMBOL_SPACE) )
      name = name2pattern(PATTERN_ESCAPE, _name);
    else
      name = namecopy(_name);
  }
}
