#include <string.h>
#include "sv_object.h"
#include "sv_object_ext.h"

//---------------------------------------------------------------------------
const char* PATTERN_FULL_NAME = "%s[%d]";

//---------------------------------------------------------------------------
ObjectExt::ObjectExt(const char* _name, int _index, Tag _tag, void* _data)
: Object(_name, _tag, _data), index(_index), depth(-1), layer(-1)
{
}

//---------------------------------------------------------------------------
ObjectExt::ObjectExt(const ObjectExt& object_ext)
: Object(object_ext), index(object_ext.index), depth(object_ext.depth), layer(object_ext.layer)
{
}

//---------------------------------------------------------------------------
ObjectExt::~ObjectExt()
{
}

//---------------------------------------------------------------------------
char* ObjectExt::genFullName() const
{
  char* name_full = NULL;
  if (index < 0)
    name_full = namecopy(name);
  else
    name_full = name2pattern(PATTERN_FULL_NAME, name, index);
  return name_full;
}
