#ifndef _SV_OBJECT_EXT_H_
#define _SV_OBJECT_EXT_H_

#include <string.h>
#include "str_utils.h"
#include "array.h"
#include "hashset.h"
#include "sv_object.h"

//---------------------------------------------------------------------------
class ObjectExt;
typedef Array<ObjectExt, ObjectCompareName> ObjectExtArray;
typedef HashSet<ObjectExt, ObjectHashName, ObjectEqualName> ObjectExtHashSet;

//---------------------------------------------------------------------------
class ObjectExt : public Object
{
  public:
    ObjectExt(const char* _name = NULL, int _index = -1, Tag _tag = TAG_UNDEFINED, void* _data = NULL);
    ObjectExt(const ObjectExt& object_ext);
    ~ObjectExt();

    void setIndex(int _index);
    int getIndex() const;
    void setDepth(int _depth);
    int getDepth() const;
    void setLayer(int _layer);
    int getLayer() const;

    char* genFullName() const;

  protected:
    int index;
    int depth;
    int layer;
};    

//---------------------------------------------------------------------------
inline void ObjectExt::setIndex(int _index)
{
  index = _index;
}

//---------------------------------------------------------------------------
inline int ObjectExt::getIndex() const
{
  return index;
}

//---------------------------------------------------------------------------
inline void ObjectExt::setDepth(int _depth)
{
  depth = _depth;
}

//---------------------------------------------------------------------------
inline int ObjectExt::getDepth() const
{
  return depth;
}

//---------------------------------------------------------------------------
inline void ObjectExt::setLayer(int _layer)
{
  layer = _layer;
}

//---------------------------------------------------------------------------
inline int ObjectExt::getLayer() const
{
  return layer;
}

#endif
