#ifndef _SV_PARAMETER_H_
#define _SV_PARAMETER_H_

#include "array.h"
#include "hashset.h"
#include "sv_object.h"

class Parameter;
typedef Array <Parameter, ObjectCompareName> ParameterArray;
typedef HashSet <Parameter, ObjectHashName, ObjectEqualName> ParameterHashSet;

//---------------------------------------------------------------------------
class Parameter : public Object
{
  public:
    Parameter(const char* _name, double _value = 0.0, Tag _tag = TAG_UNDEFINED, void* _data = NULL);
    Parameter(const Parameter& parameter);
	~Parameter();

    void setValue(double _value);
    double getValue() const;

  private:
    double value;
};

//---------------------------------------------------------------------------
inline void Parameter::setValue(double _value)
{
  value = _value;
}

//---------------------------------------------------------------------------
inline double Parameter::getValue() const
{
  return value;
}

#endif

