#ifndef _SV_PROPERTY_H_
#define _SV_PROPERTY_H_

#include "array.h"
#include "hashset.h"
#include "sv_object.h"
#include "sv_implementation.h"

//---------------------------------------------------------------------------
class Property;
typedef Array<Property, ObjectCompareName> PropertyArray;
typedef HashSet<Property, ObjectHashName, ObjectEqualName> PropertyHashSet;

//---------------------------------------------------------------------------
class Property : public Object
{
  public:
    ImplementationArray* implementations;

    Property(const char* _name, ImplementationArray* _implementations = NULL, Tag _tag = TAG_UNDEFINED, void* _data = NULL);
    Property(Property& property);
    ~Property();
    
    void addImplementation(Implementation* implementation, int position = -1);
    void addImplementations(ImplementationArray* _implementations);
    void removeImplementation(Implementation* implementation);
    Implementation* findImplementation(const char* implementation_name) const;
    
  protected:
    void clean();
};

#endif
