#ifndef _SV_RANGE_H_
#define _SV_RANGE_H_

//---------------------------------------------------------------------------
class Range
{
  public:
    Range(int _from = 0, int _to = 0);
    Range(const Range& range);
    ~Range();

    void setFrom(int _from);
    int getFrom() const;
    void setTo(int _to);
    int getTo() const;
    int getLow() const;
    int getHigh() const;
    int getInc() const;
    int getWidth() const;
    int getPosition(int index) const;
    bool isIn(int index) const;

  private:
    int from;
    int to;
};

//---------------------------------------------------------------------------
inline void Range::setFrom(int _from)
{
  from = _from;
}

//---------------------------------------------------------------------------
inline int Range::getFrom() const
{
  return from;
}

//---------------------------------------------------------------------------
inline void Range::setTo(int _to)
{
  to = _to;
}

//---------------------------------------------------------------------------
inline int Range::getTo() const
{
  return to;
}

//---------------------------------------------------------------------------
inline int Range::getLow() const
{
  return (from < to) ? from : to;
}

//---------------------------------------------------------------------------
inline int Range::getHigh() const
{
  return (from > to) ? from : to;
}

//---------------------------------------------------------------------------
inline int Range::getInc() const
{
  return (from <= to) ? 1 : -1;
}

//---------------------------------------------------------------------------
inline int Range::getWidth() const
{
  return (from <= to) ? (to - from + 1) : (from - to + 1);
}

//---------------------------------------------------------------------------
inline int Range::getPosition(int index) const
{
  return (from <= to) ? (index - from) : (from - index);
}

//---------------------------------------------------------------------------
inline bool Range::isIn(int index) const
{
  return ( ( (index >= from) && (index <= to) ) 
        || ( (index >= to) && (index <= from) ) );
}

#endif
