#ifndef _SV_SET_H_
#define _SV_SET_H_

#include <string.h>
#include "array.h"
#include "hashset.h"
#include "sv_object.h"
#include "sv_instance.h"
#include "sv_net.h"

//---------------------------------------------------------------------------
class Set;
typedef Array<Set, ObjectCompareName> SetArray;
typedef HashSet<Set, ObjectHashName, ObjectEqualName> SetHashSet;

//---------------------------------------------------------------------------
class Set : public Object
{
  public:
    InstanceArray* instances;
    NetArray* nets;
    
    Set(const char* _name, InstanceArray* _instances = NULL, NetArray* _nets = NULL, 
      Tag _tag = TAG_UNDEFINED, void* _data = NULL);
    ~Set();

    void addInstance(Instance* instance, int position = -1);
    void addInstances(InstanceArray* _instances);
    void removeInstance(Instance* instance);
    Instance* findInstance(const char* instance_name) const;

    void addNet(Net* net, int position = -1);
    void addNets(NetArray* _nets);
    void removeNet(Net* net);
    Net* findNet(const char* net_name) const;
};

#endif
